	INCLUDE EFR32MG12.inc		; CPU register definitions
	INCLUDE terminal.inc		; terminal function definitions		
	EXPORT	main

;-------------------------------------	; CODE segment in flash (ROM) 
	AREA    |.text|, CODE, READONLY
main	PROC				; main user code
	bl	Terminal_setup		; setup TeraTerm communication

loop
	ldr	R0, =prompt
	bl	WriteString		; print a prompt
	bl	ReadInt			; R0 = user input	
	bl	WriteInt		; print n
	push	{R0}			; preserve R0
	ldr	R0, =res
	bl	WriteString
	pop	{R0}

	push	{R0}			; pass parameter in stack
	bl	Factorial		; R0 = n!
	add	SP, #4			; clear stack

	bl	WriteInt		; print n!
	bl	NewLine
					
	b	loop			; repeat periodic task		
	ENDP

;----------------------------------------------------------
Factorial	PROC			; returns R0!
	push	{LR, R10}
	mov	R10, SP			; compose stack frame
	push	{R1}			; save used registers
	ldr	R1, [R10, #8]		; get param from stack
	mov	R0, #1			; init factorial value
L1	mul	R0, R0, R1		; R1 *= R0
	subs	R1, #1
	bne	L1	
	pop	{PC, R1, R10}		; restore used regs and return
	ENDP
		
;-------------------------------------
prompt	DCB	"Enter a number: ", 0	
res	DCB	"! = ", 0
	ALIGN
	END